import math
import threading
import time

from lib.controller import *
from lib.display import *


air_quality_target_value = None
humidity_target_value = None
air_quality_range = None
ventilation_index = None
humidity_range = None
ventilation_warning = None
resistance = None
illuminance = None
air_quality = None
temperature = None
humidity = None


def log_data():
    global air_quality_target_value, humidity_target_value, air_quality_range, ventilation_index, humidity_range, ventilation_warning, resistance, illuminance, air_quality, temperature, humidity
    print(round(ventilation_index, 2))


def blink():
    global air_quality_target_value, humidity_target_value, air_quality_range, ventilation_index, humidity_range, ventilation_warning, resistance, illuminance, air_quality, temperature, humidity
    while True:
        if ventilation_warning == 1:
            TXT_M_O5_led.set_brightness(512)
            time.sleep(0.5)
        TXT_M_O5_led.set_brightness(0)
        time.sleep(0.5)


air_quality_target_value = 30
humidity_target_value = 30
air_quality_range = 70
humidity_range = 25
ventilation_warning = 0
threading.Thread(target=blink, daemon=True).start()
while True:
    resistance = TXT_M_I3_photo_resistor.get_resistance()
    illuminance = (2 * math.pow(10,8)) * resistance ** (-1.74)
    air_quality = TXT_M_I2C_1_environment_sensor.get_indoor_air_quality_as_number()
    temperature = TXT_M_I2C_1_environment_sensor.get_temperature()
    humidity = TXT_M_I2C_1_environment_sensor.get_humidity()
    ventilation_index = ((humidity - humidity_target_value) / humidity_range + ((air_quality - air_quality_target_value) / air_quality_range) * 3) * 25
    if ventilation_index > 100:
        ventilation_warning = 1
    else:
        ventilation_warning = 0
    if ventilation_index <= 0:
        TXT_M_O7_led.set_brightness(512)
    else:
        TXT_M_O7_led.set_brightness(0)
    display.set_attr("humidity.text", str(''.join([str(x) for x in ['Humidity: ', round(humidity, 1), ' %']])))
    display.set_attr("temperature.text", str(''.join([str(x2) for x2 in ['Temperature: ', round(temperature, 1), ' °C']])))
    display.set_attr("air_quality.text", str('Air Quality: ' + str(air_quality)))
    display.set_attr("illuminance.text", str(''.join([str(x3) for x3 in ['Illuminance:  ', round(illuminance), ' lx']])))
    time.sleep(1)
    log_data()
